Subject: bug#65826: [PATCH] Add nonce support for gnutls-hash-mac

From: Stefan Kangas <[email-masked]>
Date: Fri, 8 Sep 2023 09:18:37 -0700

SK Kim <[email-masked]> writes:

> As far as I understood, currently `gnutls-hash-mac' does not support nonce
> input, so there is no way to properly hash with some MAC algorithms which
> require nonce. (e.g AES-GMAC-128)
> So I suggest adding an optional argument NONCE to `gnutls-hash-mac' to
> support MAC algorithms with nonce.
>
> What I have tested after applying the attached patch are as below.
> 1. AES-GMC-128/192/256 works correctly.
> 2. NONCE does not affect SHA256/SHA512 hash results, even if presented.
>
> Since NONCE is added as an optional argument, I believe it will not even
> affect existing code using the 'gnutls-hash-mac' function.

Sounds useful.  Could you add unit tests for this, though?  In
particular, it would be good to test your number 1 and 2 above.